"""
Copyright (C) Cross The Road Electronics.  All rights reserved.
License information can be found in CTRE_LICENSE.txt
For support and suggestions contact support@ctr-electronics.com or file
an issue tracker at https://github.com/CrossTheRoadElec/Phoenix-Releases
"""

from enum import Enum

class SpnValue(Enum):
    TALON_FX_SYSTEM_STATE = 612
    STARTUP_RESET_FLAGS = 633
    VERSION_MAJOR = 731
    VERSION_MINOR = 732
    VERSION_BUGFIX = 733
    VERSION_BUILD = 734
    VERSION_FULL = 735
    LICENSING_IS_PRO_LICENSED = 748
    LICENSING_IS_SEASON_PASSED = 751
    CUSTOM_PARAM0 = 816
    CUSTOM_PARAM1 = 817
    CANCODER_SENSOR_DIRECTION = 821
    FRC_LOCK = 823
    ROBOT_ENABLED = 824
    LED1_ON_COLOR = 826
    LED1_OFF_COLOR = 827
    LED2_ON_COLOR = 828
    LED2_OFF_COLOR = 829
    ALL_FAULTS = 835
    ALL_STICKY_FAULTS = 836
    PIGEON2_USE_COMPASS = 910
    PIGEON2_DISABLE_TEMPERATURE_COMPENSATION = 945
    PIGEON2_DISABLE_NO_MOTION_CALIBRATION = 947
    PIGEON2_MOUNT_POSE_YAW = 952
    PIGEON2_MOUNT_POSE_PITCH = 953
    PIGEON2_MOUNT_POSE_ROLL = 954
    PIGEON2_GYRO_SCALARX = 958
    PIGEON2_GYRO_SCALARY = 959
    PIGEON2_GYRO_SCALARZ = 960
    PIGEON2_YAW = 967
    PIGEON2_PITCH = 968
    PIGEON2_ROLL = 969
    PIGEON2_QUATW = 970
    PIGEON2_QUATX = 971
    PIGEON2_QUATY = 972
    PIGEON2_QUATZ = 973
    PIGEON2_GRAVITY_VECTORX = 974
    PIGEON2_GRAVITY_VECTORY = 975
    PIGEON2_GRAVITY_VECTORZ = 976
    PIGEON2_TEMPERATURE = 977
    PIGEON2_NO_MOTION_CAL_ENABLED = 978
    PIGEON2_NO_MOTION_COUNT = 979
    PIGEON2_TEMP_COMP_DISABLED = 980
    PIGEON2_UP_TIME = 981
    PIGEON2_ACCUM_GYROX = 982
    PIGEON2_ACCUM_GYROY = 983
    PIGEON2_ACCUM_GYROZ = 984
    PIGEON2_ANGULAR_VELOCITYX = 985
    PIGEON2_ANGULAR_VELOCITYY = 986
    PIGEON2_ANGULAR_VELOCITYZ = 987
    PIGEON2_ACCELERATIONX = 988
    PIGEON2_ACCELERATIONY = 989
    PIGEON2_ACCELERATIONZ = 990
    PIGEON2_SUPPLY_VOLTAGE = 991
    PIGEON2_MAGNETIC_FIELDX = 996
    PIGEON2_MAGNETIC_FIELDY = 997
    PIGEON2_MAGNETIC_FIELDZ = 998
    PIGEON2_RAW_MAGNETIC_FIELDX = 999
    PIGEON2_RAW_MAGNETIC_FIELDY = 1000
    PIGEON2_RAW_MAGNETIC_FIELDZ = 1001
    CANCODER_MAGNET_OFFSET = 1002
    CANCODER_ABSOLUTE_SENSOR_RANGE = 1003
    TALON_FX_SET_SENSOR_POSITION = 1007
    CANCODER_SET_SENSOR_POSITION = 1009
    PIGEON2_SET_YAW = 1011
    DEVICE_ENABLED = 1040
    PRO_MOTOR_OUTPUT_MOTOR_VOLTAGE = 1907
    FORWARD_LIMIT = 1908
    REVERSE_LIMIT = 1909
    PRO_MOTOR_OUTPUT_ROTOR_POLARITY = 1910
    PRO_MOTOR_OUTPUT_DUTY_CYCLE = 1911
    PRO_MOTOR_OUTPUT_TORQUE_CURRENT = 1913
    PRO_SUPPLY_AND_TEMP_STATOR_CURRENT = 1914
    PRO_SUPPLY_AND_TEMP_SUPPLY_CURRENT = 1915
    PRO_SUPPLY_AND_TEMP_SUPPLY_VOLTAGE = 1916
    PRO_SUPPLY_AND_TEMP_DEVICE_TEMP = 1917
    PRO_SUPPLY_AND_TEMP_PROCESSOR_TEMP = 1918
    PRO_ROTOR_POS_AND_VEL_VELOCITY = 1920
    PRO_ROTOR_POS_AND_VEL_POSITION = 1921
    PRO_POS_AND_VEL_VELOCITY = 1924
    PRO_POS_AND_VEL_POSITION = 1925
    PRO_POS_AND_VEL_ACCELERATION = 1926
    PRO_PIDSTATE_ENABLES_INTEGRATED_ACCUM_DC = 1928
    PRO_PIDSTATE_ENABLES_INTEGRATED_ACCUM_V = 1929
    PRO_PIDSTATE_ENABLES_INTEGRATED_ACCUM_A = 1930
    PRO_PIDSTATE_ENABLES_FEED_FORWARD_DC = 1931
    PRO_PIDSTATE_ENABLES_FEED_FORWARD_V = 1932
    PRO_PIDSTATE_ENABLES_FEED_FORWARD_A = 1933
    TALON_FX_CONTROL_MODE = 1934
    PRO_PIDSTATE_ENABLES_IS_MOTION_MAGIC_RUNNING = 1935
    PRO_PIDSTATE_ENABLES_DEVICE_ENABLE = 1937
    PRO_PIDREF_PIDERR_PIDREF_POSITION = 1939
    PRO_PIDREF_PIDERR_PIDREF_VELOCITY = 1940
    PRO_PIDREF_PIDERR_PIDERR_POSITION = 1941
    PRO_PIDREF_PIDERR_PIDERR_VELOCITY = 1942
    PRO_PIDOUTPUT_PROPORTIONAL_OUTPUT_DC = 1944
    PRO_PIDOUTPUT_PROPORTIONAL_OUTPUT_V = 1945
    PRO_PIDOUTPUT_PROPORTIONAL_OUTPUT_A = 1946
    PRO_PIDOUTPUT_DERIVATIVE_OUTPUT_DC = 1947
    PRO_PIDOUTPUT_DERIVATIVE_OUTPUT_V = 1948
    PRO_PIDOUTPUT_DERIVATIVE_OUTPUT_A = 1949
    PRO_PIDOUTPUT_OUTPUT_DC = 1950
    PRO_PIDOUTPUT_OUTPUT_V = 1951
    PRO_PIDOUTPUT_OUTPUT_A = 1952
    PRO_PIDOUTPUT_SLOT = 1953
    PRO_PIDREF_SLOPE_ECUTIME_REFERENCE_SLOPE_POSITION = 1954
    PRO_PIDREF_SLOPE_ECUTIME_REFERENCE_SLOPE_VELOCITY = 1955
    PRO_MOTOR_OUTPUT_PIDSTATE_DIFF_DUTY_CYCLE = 1958
    PRO_MOTOR_OUTPUT_PIDSTATE_DIFF_TORQUE_CURRENT = 1959
    TALON_FX_DIFFERENTIAL_CONTROL_MODE = 1962
    PRO_MOTOR_OUTPUT_PIDSTATE_DIFF_INTEGRATED_ACCUM_DC = 1963
    PRO_MOTOR_OUTPUT_PIDSTATE_DIFF_INTEGRATED_ACCUM_V = 1964
    PRO_MOTOR_OUTPUT_PIDSTATE_DIFF_INTEGRATED_ACCUM_A = 1965
    PRO_MOTOR_OUTPUT_PIDSTATE_DIFF_FEED_FORWARD_DC = 1966
    PRO_MOTOR_OUTPUT_PIDSTATE_DIFF_FEED_FORWARD_V = 1967
    PRO_MOTOR_OUTPUT_PIDSTATE_DIFF_FEED_FORWARD_A = 1968
    PRO_AVG_POS_AND_VEL_VELOCITY = 1970
    PRO_AVG_POS_AND_VEL_POSITION = 1971
    PRO_DIFF_POS_AND_VEL_VELOCITY = 1974
    PRO_DIFF_POS_AND_VEL_POSITION = 1975
    PRO_DIFF_PIDREF_PIDERR_PIDREF_POSITION = 1977
    PRO_DIFF_PIDREF_PIDERR_PIDREF_VELOCITY = 1978
    PRO_DIFF_PIDREF_PIDERR_PIDERR_POSITION = 1979
    PRO_DIFF_PIDREF_PIDERR_PIDERR_VELOCITY = 1980
    PRO_DIFF_PIDOUTPUT_PROPORTIONAL_OUTPUT_DC = 1982
    PRO_DIFF_PIDOUTPUT_PROPORTIONAL_OUTPUT_V = 1983
    PRO_DIFF_PIDOUTPUT_PROPORTIONAL_OUTPUT_A = 1984
    PRO_DIFF_PIDOUTPUT_DERIVATIVE_OUTPUT_DC = 1985
    PRO_DIFF_PIDOUTPUT_DERIVATIVE_OUTPUT_V = 1986
    PRO_DIFF_PIDOUTPUT_DERIVATIVE_OUTPUT_A = 1987
    PRO_DIFF_PIDOUTPUT_OUTPUT_DC = 1988
    PRO_DIFF_PIDOUTPUT_OUTPUT_V = 1989
    PRO_DIFF_PIDOUTPUT_OUTPUT_A = 1990
    PRO_DIFF_PIDOUTPUT_SLOT = 1991
    PRO_DIFF_PIDREF_SLOPE_ECUTIME_REFERENCE_SLOPE_POSITION = 1992
    PRO_DIFF_PIDREF_SLOPE_ECUTIME_REFERENCE_SLOPE_VELOCITY = 1993
    SLOT0_KP = 1995
    SLOT0_KI = 1996
    SLOT0_KD = 1997
    SLOT0_KS = 1998
    SLOT0_KV = 1999
    SLOT0_KA = 2000
    SLOT0_KG = 2001
    SLOT0_KG_TYPE = 2002
    SLOT1_KP = 2003
    SLOT1_KI = 2004
    SLOT1_KD = 2005
    SLOT1_KS = 2006
    SLOT1_KV = 2007
    SLOT1_KA = 2008
    SLOT1_KG = 2009
    SLOT1_KG_TYPE = 2010
    SLOT2_KP = 2011
    SLOT2_KI = 2012
    SLOT2_KD = 2013
    SLOT2_KS = 2014
    SLOT2_KV = 2015
    SLOT2_KA = 2016
    SLOT2_KG = 2017
    SLOT2_KG_TYPE = 2018
    CONFIG_INVERTED = 2019
    CONFIG_SUPPLY_VLOWPASS_TAU = 2020
    CONFIG_BEEP_ON_BOOT = 2021
    CONFIG_NEUTRAL_MODE = 2022
    CONFIG_DUTY_CYCLE_NEUTRAL_DB = 2023
    CONFIG_STATOR_CURRENT_LIMIT = 2024
    CONFIG_STATOR_CURR_LIMIT_EN = 2025
    CONFIG_SUPPLY_CURRENT_LIMIT = 2026
    CONFIG_SUPPLY_CURR_LIMIT_EN = 2027
    CONFIG_PEAK_FORWARD_DC = 2028
    CONFIG_PEAK_REVERSE_DC = 2029
    CONFIG_PEAK_FORWARDV = 2030
    CONFIG_PEAK_REVERSEV = 2031
    CONFIG_PEAK_FOR_TORQ_CURR = 2032
    CONFIG_PEAK_REV_TORQ_CURR = 2033
    CONFIG_TORQUE_NEUTRAL_DB = 2034
    CONFIG_FEEDBACK_ROTOR_OFFSET = 2035
    CONFIG_SENSOR_TO_MECHANISM_RATIO = 2036
    CONFIG_ROTOR_TO_SENSOR_RATIO = 2037
    CONFIG_FEEDBACK_SENSOR_SOURCE = 2038
    CONFIG_FEEDBACK_REMOTE_SENSOR_ID = 2039
    CONFIG_DUTY_CYCLE_OPEN_LOOP_RAMP_PERIOD = 2040
    CONFIG_VOLTAGE_OPEN_LOOP_RAMP_PERIOD = 2041
    CONFIG_TORQUE_OPEN_LOOP_RAMP_PERIOD = 2042
    CONFIG_DUTY_CYCLE_CLOSED_LOOP_RAMP_PERIOD = 2043
    CONFIG_VOLTAGE_CLOSED_LOOP_RAMP_PERIOD = 2044
    CONFIG_TORQUE_CLOSED_LOOP_RAMP_PERIOD = 2045
    CONFIG_FORWARD_LIMIT_TYPE = 2046
    CONFIG_FORWARD_LIMIT_AUTOSET_POS_ENABLE = 2047
    CONFIG_FORWARD_LIMIT_AUTOSET_POS_VALUE = 2048
    CONFIG_FORWARD_LIMIT_ENABLE = 2049
    CONFIG_FORWARD_LIMIT_SOURCE = 2050
    CONFIG_FORWARD_LIMIT_REMOTE_SENSOR_ID = 2051
    CONFIG_REVERSE_LIMIT_TYPE = 2052
    CONFIG_REVERSE_LIMIT_AUTOSET_POS_ENABLE = 2053
    CONFIG_REVERSE_LIMIT_AUTOSET_POS_VALUE = 2054
    CONFIG_REVERSE_LIMIT_ENABLE = 2055
    CONFIG_REVERSE_LIMIT_SOURCE = 2056
    CONFIG_REVERSE_LIMIT_REMOTE_SENSOR_ID = 2057
    CONFIG_FORWARD_SOFT_LIMIT_ENABLE = 2058
    CONFIG_REVERSE_SOFT_LIMIT_ENABLE = 2059
    CONFIG_FORWARD_SOFT_LIMIT_THRESHOLD = 2060
    CONFIG_REVERSE_SOFT_LIMIT_THRESHOLD = 2061
    CONFIG_MOTION_MAGIC_CRUISE_VELOCITY = 2062
    CONFIG_MOTION_MAGIC_ACCELERATION = 2063
    CONFIG_MOTION_MAGIC_JERK = 2064
    CONFIG_PEAK_DIFF_DC = 2065
    CONFIG_PEAK_DIFFV = 2066
    CONFIG_PEAK_DIFF_TORQ_CURR = 2067
    CANCODER_VELOCITY = 2068
    CANCODER_POSITION = 2069
    CANCODER_ABS_POSITION = 2070
    CANCODER_RAW_VEL = 2072
    CANCODER_RAW_POS = 2073
    CANCODER_SUPPLY_VOLTAGE = 2074
    CANCODER_MAG_HEALTH = 2075
    SPN_CLEAR_STICKY_FAULTS = 2078
    PRO_MOTOR_OUTPUT_BRIDGE_TYPE_PUBLIC = 2079
    CONFIG_CONTINUOUS_WRAP = 2101
    CONFIG_SUPPLY_CURR_THRES = 2107
    CONFIG_SUPPLY_TIME_THRES = 2108
    CONFIG_DIFFERENTIAL_SENSOR_SOURCE = 2122
    CONFIG_DIFFERENTIAL_TALON_FXSENSOR_ID = 2123
    CONFIG_DIFFERENTIAL_REMOTE_SENSOR_ID = 2124
    CONFIG_BEEP_ON_CONFIG = 2163
    CONFIG_ALLOW_MUSIC_DUR_DISABLE = 2164
    COMPLIANCY_VERSION = 2165
    VERSION_IS_PRO_LICENSED = 2166
    PRO_SUPPLY_AND_TEMP_DEVICE_TEMP2 = 2205
    FAULT_HARDWARE = 10001
    STICKY_FAULT_HARDWARE = 10002
    CLEAR_STICKY_FAULT_HARDWARE = 10003
    FAULT_PROC_TEMP = 10004
    STICKY_FAULT_PROC_TEMP = 10005
    CLEAR_STICKY_FAULT_PROC_TEMP = 10006
    FAULT_DEVICE_TEMP = 10007
    STICKY_FAULT_DEVICE_TEMP = 10008
    CLEAR_STICKY_FAULT_DEVICE_TEMP = 10009
    FAULT_UNDERVOLTAGE = 10010
    STICKY_FAULT_UNDERVOLTAGE = 10011
    CLEAR_STICKY_FAULT_UNDERVOLTAGE = 10012
    FAULT_BOOT_DURING_ENABLE = 10013
    STICKY_FAULT_BOOT_DURING_ENABLE = 10014
    CLEAR_STICKY_FAULT_BOOT_DURING_ENABLE = 10015
    FAULT_UNLICENSED_FEATURE_IN_USE = 10016
    STICKY_FAULT_UNLICENSED_FEATURE_IN_USE = 10017
    FAULT_PIGEON2_BOOTUP_ACCEL = 10019
    STICKY_FAULT_PIGEON2_BOOTUP_ACCEL = 10020
    CLEAR_STICKY_FAULT_PIGEON2_BOOTUP_ACCEL = 10021
    FAULT_PIGEON2_BOOTUP_GYROS = 10022
    STICKY_FAULT_PIGEON2_BOOTUP_GYROS = 10023
    CLEAR_STICKY_FAULT_PIGEON2_BOOTUP_GYROS = 10024
    FAULT_PIGEON2_BOOTUP_MAGNE = 10025
    STICKY_FAULT_PIGEON2_BOOTUP_MAGNE = 10026
    CLEAR_STICKY_FAULT_PIGEON2_BOOTUP_MAGNE = 10027
    FAULT_PIGEON2_BOOT_INTO_MOTION = 10028
    STICKY_FAULT_PIGEON2_BOOT_INTO_MOTION = 10029
    CLEAR_STICKY_FAULT_PIGEON2_BOOT_INTO_MOTION = 10030
    FAULT_PIGEON2_DATA_ACQUIRED_LATE = 10031
    STICKY_FAULT_PIGEON2_DATA_ACQUIRED_LATE = 10032
    CLEAR_STICKY_FAULT_PIGEON2_DATA_ACQUIRED_LATE = 10033
    FAULT_PIGEON2_LOOP_TIME_SLOW = 10034
    STICKY_FAULT_PIGEON2_LOOP_TIME_SLOW = 10035
    CLEAR_STICKY_FAULT_PIGEON2_LOOP_TIME_SLOW = 10036
    FAULT_PIGEON2_SATURATED_MAGNE = 10037
    STICKY_FAULT_PIGEON2_SATURATED_MAGNE = 10038
    CLEAR_STICKY_FAULT_PIGEON2_SATURATED_MAGNE = 10039
    FAULT_PIGEON2_SATURATED_ACCEL = 10040
    STICKY_FAULT_PIGEON2_SATURATED_ACCEL = 10041
    CLEAR_STICKY_FAULT_PIGEON2_SATURATED_ACCEL = 10042
    FAULT_PIGEON2_SATURATED_GYROS = 10043
    STICKY_FAULT_PIGEON2_SATURATED_GYROS = 10044
    CLEAR_STICKY_FAULT_PIGEON2_SATURATED_GYROS = 10045
    FAULT_CANCODER_BAD_MAGNET = 10046
    STICKY_FAULT_CANCODER_BAD_MAGNET = 10047
    CLEAR_STICKY_FAULT_CANCODER_BAD_MAGNET = 10048
    FAULT_TALONFX_BRIDGE_BROWNOUT = 10049
    STICKY_FAULT_TALONFX_BRIDGE_BROWNOUT = 10050
    CLEAR_STICKY_FAULT_TALONFX_BRIDGE_BROWNOUT = 10051
    FAULT_TALONFX_REMOTE_SENSOR_RESET = 10052
    STICKY_FAULT_TALONFX_REMOTE_SENSOR_RESET = 10053
    CLEAR_STICKY_FAULT_TALONFX_REMOTE_SENSOR_RESET = 10054
    FAULT_TALONFX_MISSING_DIFFERENTIAL_FX = 10055
    STICKY_FAULT_TALONFX_MISSING_DIFFERENTIAL_FX = 10056
    CLEAR_STICKY_FAULT_TALONFX_MISSING_DIFFERENTIAL_FX = 10057
    FAULT_TALONFX_REMOTE_SENSOR_POS_OVERFLOW = 10058
    STICKY_FAULT_TALONFX_REMOTE_SENSOR_POS_OVERFLOW = 10059
    CLEAR_STICKY_FAULT_TALONFX_REMOTE_SENSOR_POS_OVERFLOW = 10060
    FAULT_TALONFX_OVER_SUPPLYV = 10061
    STICKY_FAULT_TALONFX_OVER_SUPPLYV = 10062
    CLEAR_STICKY_FAULT_TALONFX_OVER_SUPPLYV = 10063
    FAULT_TALONFX_UNSTABLE_SUPPLYV = 10064
    STICKY_FAULT_TALONFX_UNSTABLE_SUPPLYV = 10065
    CLEAR_STICKY_FAULT_TALONFX_UNSTABLE_SUPPLYV = 10066
    FAULT_TALONFX_REVERSE_HARD_LIMIT = 10067
    STICKY_FAULT_TALONFX_REVERSE_HARD_LIMIT = 10068
    CLEAR_STICKY_FAULT_TALONFX_REVERSE_HARD_LIMIT = 10069
    FAULT_TALONFX_FORWARD_HARD_LIMIT = 10070
    STICKY_FAULT_TALONFX_FORWARD_HARD_LIMIT = 10071
    CLEAR_STICKY_FAULT_TALONFX_FORWARD_HARD_LIMIT = 10072
    FAULT_TALONFX_REVERSE_SOFT_LIMIT = 10073
    STICKY_FAULT_TALONFX_REVERSE_SOFT_LIMIT = 10074
    CLEAR_STICKY_FAULT_TALONFX_REVERSE_SOFT_LIMIT = 10075
    FAULT_TALONFX_FORWARD_SOFT_LIMIT = 10076
    STICKY_FAULT_TALONFX_FORWARD_SOFT_LIMIT = 10077
    CLEAR_STICKY_FAULT_TALONFX_FORWARD_SOFT_LIMIT = 10078
    FAULT_TALONFX_MISSING_REMOTE_SENSOR = 10085
    STICKY_FAULT_TALONFX_MISSING_REMOTE_SENSOR = 10086
    CLEAR_STICKY_FAULT_TALONFX_MISSING_REMOTE_SENSOR = 10087
    FAULT_TALONFX_FUSED_SENSOR_OUT_OF_SYNC = 10088
    STICKY_FAULT_TALONFX_FUSED_SENSOR_OUT_OF_SYNC = 10089
    CLEAR_STICKY_FAULT_TALONFX_FUSED_SENSOR_OUT_OF_SYNC = 10090
    FAULT_TALONFX_STATOR_CURR_LIMIT = 10091
    STICKY_FAULT_TALONFX_STATOR_CURR_LIMIT = 10092
    CLEAR_STICKY_FAULT_TALONFX_STATOR_CURR_LIMIT = 10093
    FAULT_TALONFX_SUPPLY_CURR_LIMIT = 10094
    STICKY_FAULT_TALONFX_SUPPLY_CURR_LIMIT = 10095
    CLEAR_STICKY_FAULT_TALONFX_SUPPLY_CURR_LIMIT = 10096
    FAULT_TALONFX_USING_FUSED_CCWHILE_UNLICENSED = 10097
    STICKY_FAULT_TALONFX_USING_FUSED_CCWHILE_UNLICENSED = 10098